package com.codigoparallevar.minicards.types;

import com.codigoparallevar.minicards.types.connectors.input.InputConnector;
import com.codigoparallevar.minicards.types.connectors.input.SignalInputConnector;
import com.codigoparallevar.minicards.types.connectors.output.OutputConnector;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;

public interface Part extends Selectable, Moveable, Drawable {
    int getLeft();
    int getRight();
    int getTop();
    int getBottom();

    void touched();

    List<SignalInputConnector> getSignalInputConnectors();
    List<OutputConnector> getOutputConnectors();

    JSONObject serialize() throws JSONException;

    void sendSignal(RoundInputConnector roundInputConnector);

    String getId();

    InputConnector getConnectorWithId(String inputConnectorId);

    String getConnectorId(InputConnector inputConnector);

}
